import json


def write_config_value(section, key, value):
    with open("settings/" + section + ".json", "r+") as fp:
        opt = json.load(fp)
        opt[key] = value
        fp.seek(0)
        fp.truncate()
        json.dump(opt, fp, indent=4)


def get_config_value(section, key, fallback=""):
    with open("settings/" + section + ".json", "r") as f:
        try:
            value = json.load(f)[key]
        except KeyError:
            # Value does not exist
            value = fallback
            write_config_value(section, key, fallback)
        return value
